﻿using System.Linq;
using HeuristicLab.Analysis.SolutionCaching;
using HeuristicLab.Analysis.SolutionCaching.PermutationEncoding;
using HeuristicLab.Encodings.PermutationEncoding;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace AlgorithmBehaviorUnitTests {
  [TestClass]
  public class UnitTest2 {
    [TestMethod]
    public void TestPermutationSolutionDictionary() {
      var rand = new HeuristicLab.Random.FastRandom();
      PermutationEqualityComparer comp = new PermutationEqualityComparer();
      PermutationSolutionCache dict = new PermutationSolutionCache();
      int realDuplicates = 0;
      int noDuplicates = 0;

      Permutation[] permutations = new Permutation[500];
      for (int i = 0; i < permutations.Length; i += 2) {
        var p = new Permutation(PermutationTypes.RelativeUndirected, 21, rand);
        permutations[i] = p;
        permutations[i + 1] = p;

        PermutationSolutionInformation pi = new PermutationSolutionInformation();
        pi.Generation = rand.Next(0, 100);
        pi.ProducedBy = ProducedBy.Mutation;

        dict.Add(p, pi);
      }

      for (int i = 0; i < permutations.Length; i++) {
        for (int j = i + 1; j < permutations.Length; j++) {
          if (comp.Equals(permutations[i], permutations[j])) {
            realDuplicates++;
            break;
          }
        }
      }

      for (int i = 0; i < dict.SolutionDictionary.Keys.Count; i++) {
        for (int j = i + 1; j < dict.SolutionDictionary.Keys.Count; j++) {
          if (comp.Equals(dict.SolutionDictionary.Keys.ElementAt(i), dict.SolutionDictionary.Keys.ElementAt(j))) {
            noDuplicates++;
            break;
          }
        }
      }

      Assert.AreNotEqual(0, realDuplicates);
      Assert.AreEqual(0, noDuplicates);
      Assert.AreEqual(250, dict.SolutionDictionary.Keys.Count);
    }
  }
}
